/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Vista;

import Negocio.BookClass;
import Negocio.BookProcess;
import Negocio.PrestamosProcess;
import Negocio.UserProcess;
import java.beans.PropertyVetoException;
import java.sql.SQLException;
import java.text.ParseException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Abraham Fernandez Sanchez
 */
public class PrestamoNewBookVista extends javax.swing.JInternalFrame {

    Escritorio escritorio;
    BookProcess bookProcess;
    BookClass book;
    UserProcess user;
    PrestamosProcess prestamoProcess;

    /**
     * Creates new form PrestamoLibroVista
     *
     * @param escritorio Objeto de la clase Escritorio
     */
    public PrestamoNewBookVista(Escritorio escritorio) {
        this.escritorio = escritorio;
        initComponents();
        this.setSize(315, 100);
        off();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanelCabeceraPrestarLibro = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jTextFieldNumISBNBuscar = new javax.swing.JTextField();
        jButtonBuscar = new javax.swing.JButton();
        jPanelCuerpoPrestarLibro = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldTitulo = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jTextFieldEditorial = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldNumISBN = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        jLabel7 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jTextFieldNumCarnet = new javax.swing.JTextField();
        jPanelBotonera = new javax.swing.JPanel();
        jButtonAceptar = new javax.swing.JButton();
        jButtonReset = new javax.swing.JButton();
        jButtonCancelar = new javax.swing.JButton();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setTitle("Prestamo de Libro");
        setPreferredSize(new java.awt.Dimension(360, 380));

        jPanelCabeceraPrestarLibro.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));

        jLabel2.setText("Nº ISBN :");

        jButtonBuscar.setText("Buscar");
        jButtonBuscar.setToolTipText("Busca el numero ISBN a prestar");
        jButtonBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonBuscarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelCabeceraPrestarLibroLayout = new javax.swing.GroupLayout(jPanelCabeceraPrestarLibro);
        jPanelCabeceraPrestarLibro.setLayout(jPanelCabeceraPrestarLibroLayout);
        jPanelCabeceraPrestarLibroLayout.setHorizontalGroup(
            jPanelCabeceraPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelCabeceraPrestarLibroLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelCabeceraPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator1)
                    .addGroup(jPanelCabeceraPrestarLibroLayout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(18, 18, 18)
                        .addComponent(jTextFieldNumISBNBuscar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonBuscar)))
                .addContainerGap())
        );
        jPanelCabeceraPrestarLibroLayout.setVerticalGroup(
            jPanelCabeceraPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelCabeceraPrestarLibroLayout.createSequentialGroup()
                .addGroup(jPanelCabeceraPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldNumISBNBuscar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButtonBuscar)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel3.setText("Titulo :");

        jTextFieldTitulo.setEditable(false);
        jTextFieldTitulo.setFocusable(false);

        jLabel4.setText("Editorial :");

        jTextFieldEditorial.setEditable(false);
        jTextFieldEditorial.setFocusable(false);

        jLabel5.setText("Nº ISBN : ");

        jTextFieldNumISBN.setEditable(false);
        jTextFieldNumISBN.setFocusable(false);

        jLabel6.setText("Libro a prestar : ");

        jLabel7.setText("Usuario :");

        jLabel1.setText("Nº Carnet :");

        javax.swing.GroupLayout jPanelCuerpoPrestarLibroLayout = new javax.swing.GroupLayout(jPanelCuerpoPrestarLibro);
        jPanelCuerpoPrestarLibro.setLayout(jPanelCuerpoPrestarLibroLayout);
        jPanelCuerpoPrestarLibroLayout.setHorizontalGroup(
            jPanelCuerpoPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelCuerpoPrestarLibroLayout.createSequentialGroup()
                .addGroup(jPanelCuerpoPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelCuerpoPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jTextFieldNumISBN)
                    .addComponent(jTextFieldTitulo)
                    .addComponent(jTextFieldEditorial)))
            .addComponent(jSeparator2)
            .addGroup(jPanelCuerpoPrestarLibroLayout.createSequentialGroup()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextFieldNumCarnet))
            .addGroup(jPanelCuerpoPrestarLibroLayout.createSequentialGroup()
                .addGroup(jPanelCuerpoPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanelCuerpoPrestarLibroLayout.setVerticalGroup(
            jPanelCuerpoPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelCuerpoPrestarLibroLayout.createSequentialGroup()
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelCuerpoPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jTextFieldNumISBN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelCuerpoPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldTitulo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelCuerpoPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jTextFieldEditorial, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelCuerpoPrestarLibroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldNumCarnet, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jButtonAceptar.setText("Aceptar Prestamo");
        jButtonAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonAceptarActionPerformed(evt);
            }
        });

        jButtonReset.setText("Reset");
        jButtonReset.setToolTipText("Cancela la busqueda y espera una nueva.");
        jButtonReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResetActionPerformed(evt);
            }
        });

        jButtonCancelar.setText("Cancelar");
        jButtonCancelar.setToolTipText("Cancela completamente la accion y sale de la ventana");
        jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelBotoneraLayout = new javax.swing.GroupLayout(jPanelBotonera);
        jPanelBotonera.setLayout(jPanelBotoneraLayout);
        jPanelBotoneraLayout.setHorizontalGroup(
            jPanelBotoneraLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelBotoneraLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jButtonAceptar)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonReset)
                .addGap(5, 5, 5)
                .addComponent(jButtonCancelar)
                .addContainerGap())
        );
        jPanelBotoneraLayout.setVerticalGroup(
            jPanelBotoneraLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelBotoneraLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelBotoneraLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonAceptar)
                    .addComponent(jButtonReset)
                    .addComponent(jButtonCancelar))
                .addGap(0, 6, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanelCabeceraPrestarLibro, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanelCuerpoPrestarLibro, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanelBotonera, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanelCabeceraPrestarLibro, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanelCuerpoPrestarLibro, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanelBotonera, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonBuscarActionPerformed
        try {
            buscarBook();
        } catch (SQLException ex) {
            Logger.getLogger(PrestamoNewBookVista.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonBuscarActionPerformed

    private void jButtonResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResetActionPerformed
        reset();
    }//GEN-LAST:event_jButtonResetActionPerformed

    private void jButtonCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelarActionPerformed
        try {
            this.setClosed(true);//metodo para cerrar este frame
        } catch (PropertyVetoException ex) {
            Logger.getLogger(AddUsuarioVista.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonCancelarActionPerformed

    private void jButtonAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAceptarActionPerformed
        try {
            prestarLibro();
        } catch (SQLException | ParseException ex) {
            Logger.getLogger(PrestamoNewBookVista.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonAceptarActionPerformed

    /**
     * Metodo que realizara todas las operaciones oportunas para buscar el libro
     * indicado
     */
    private void buscarBook() throws SQLException {
        bookProcess = new BookProcess();
        prestamoProcess = new PrestamosProcess();
        String isbn = jTextFieldNumISBNBuscar.getText();
        if (bookProcess.isISBNExist(isbn)) {
            if (prestamoProcess.isPrestadoBookOnlyIsbn(isbn)) {
                JOptionPane.showMessageDialog(this, "El libro solicitado esta actualmente en prestamo");
                return;
            }
            try {
                book = bookProcess.getBook(isbn);
                jTextFieldNumISBN.setText(book.getIsbn());
                jTextFieldTitulo.setText(book.getTitulo());
                jTextFieldEditorial.setText(book.getEditorial());
                this.setSize(315, 317);
                on();
            } catch (SQLException ex) {
                Logger.getLogger(PrestamoNewBookVista.class.getName()).log(Level.SEVERE, null, ex);
            }
        } else {
            off();
            respuestasJOptionPane(false);
        }
    }//END buscarBook

    /**
     *Metodo para restear la informacion que es mostrada
     */
    private void reset() {
        off();
        this.setSize(315, 100);
        jTextFieldNumISBNBuscar.setText("");
    }

    /**
     * Solicitud de prestamo de libro<br>
     *
     * Metodo para llamar a las demas funciones que tienen como objetivo la
     * validacion y posterior actualizacion de informacion
     *
     */
    private void prestarLibro() throws SQLException, ParseException {
        String isbn = jTextFieldNumISBN.getText();
        String numCarnet = jTextFieldNumCarnet.getText();
        prestamoProcess = new PrestamosProcess();
        if (prestamoProcess.prestarLibro(isbn, numCarnet)) {
            respuestasJOptionPane(true);
            off();
            try {
                this.setClosed(true);//metodo para cerrar este frame
            } catch (PropertyVetoException ex) {
                Logger.getLogger(AddUsuarioVista.class.getName()).log(Level.SEVERE, null, ex);
            }
        } else {
            off();
            respuestasJOptionPane(false);
        }
    }

    /**
     *
     * Respuestas textuales al prestamo<br>
     *
     * Metodo del que se obtienen las respuestas textuales
     *
     * @param request
     */
    private void respuestasJOptionPane(boolean request) {

        if (request) {
            JOptionPane.showMessageDialog(escritorio, "El libro ha sido Prestado");
        } else {
            JOptionPane.showMessageDialog(escritorio, "El libro solicitado no esta actualmente disponible para prestamo");
        }

    }

    /**
     *
     */
    private void on() {
        jPanelCuerpoPrestarLibro.setVisible(true);
        jPanelCabeceraPrestarLibro.setVisible(false);
//        jPanelTextoNoLibro.setVisible(false);
        jPanelBotonera.setVisible(true);
    }

    /**
     *
     */
    private void off() {
        jPanelCuerpoPrestarLibro.setVisible(false);
//        jPanelTextoNoLibro.setVisible(false);
        jPanelBotonera.setVisible(false);
        jPanelCabeceraPrestarLibro.setVisible(true);
    }

    private void clearJText() {

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonAceptar;
    private javax.swing.JButton jButtonBuscar;
    private javax.swing.JButton jButtonCancelar;
    private javax.swing.JButton jButtonReset;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanelBotonera;
    private javax.swing.JPanel jPanelCabeceraPrestarLibro;
    private javax.swing.JPanel jPanelCuerpoPrestarLibro;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JTextField jTextFieldEditorial;
    private javax.swing.JTextField jTextFieldNumCarnet;
    private javax.swing.JTextField jTextFieldNumISBN;
    private javax.swing.JTextField jTextFieldNumISBNBuscar;
    private javax.swing.JTextField jTextFieldTitulo;
    // End of variables declaration//GEN-END:variables

}
